function max(a,b){ return a>b?a:b} 
NR==1{ for(i=3;i<=NF;i+=2) id[$i]=i+1; 
t1=$1
       c1=max(0,$(id["current"]))
       if (c1 < 0.01) c1 = 0;
       v1=max(0,$(id["cell_voltage"]))
}

{
    t2=$1;
    c2=max(0,$(id["current"]));
    if (c2 < 0.01) c2 = 0;
    v2=max(0,$(id["cell_voltage"]));
    
    coulomb+=(t2-t1)*(c1+c2)*1800.0;
    if (v2 > 10000) v2=0; 
    if (v1 > 10000) v1=0; 
    if (v1 < -10000) v1=0;
    if (v2 < -10000) v2=0;
    vavg=(v1+v2)/2000.0; #mV
    joule+=(t2-t1)*(c1+c2)*1800.0*vavg;
    print $0, "coulomb ",coulomb, "ampere-hours ",coulomb/3600.0,"joule", joule ;
    t1=t2;
    c1=c2;
    v1=v2;
    
}

#END{ for ( i in id) print i,id[i]}
